/***************************************************************
/  USB ADVANCE LOADER FOR PS3                                  /
/  Copyright (C) 2009 - Ifcaro <http://ps2dev.ifcaro.net>      /
/                                                              /
/  last mod: 26-04-2009                                        /
/  license:  GNU Library General Public License Version 2      /
/            (see LICENSE on the main directory)               /
***************************************************************/

#include "include/usbld.h"
#define JAL(addr)	(0x0c000000 | (0x3ffffff & ((addr) >> 2)))

int ptr=0x000FF000; 
int engui=0;

extern void *usbadvn_elf;
extern void *parche_ee_bin;
extern int size_parche_ee_bin;

extern void *load_usbd_irx;
extern int size_load_usbd_irx;

extern void *usbd_irx;
extern int size_usbd_irx;

extern int PAL;
extern int driverexterno;
extern int idioma;
extern int disableformat;

extern char txt_formatdisabled[64];
extern char txt_formatbuttonisdisabled[64];
extern char txt_youcanchange[64];

/*
 * This function applies all patches to original USB ADVANCE executable
 * is called by changing SifIopReset offset in the USBADVN elf.
 */
void parches(){

	//Reset that we replaced in elf
	Reset();
	
	//Module injection 
	jal_patch((void*)ExtraeModulo, 42684);
	jal_patch((void*)ExtraeModulo, 69912);
	
	//USBD.IRX size
	if(driverexterno==0){
		gen_patch(size_usbd_irx, 3279504); //ingame
		gen_patch(size_usbd_irx, 1299120); //gui
	}else{
		gen_patch(size_load_usbd_irx, 3279504); //ingame
		gen_patch(size_load_usbd_irx, 1299120); //gui

	}
	
	//MSD.IRX size
	//gen_patch(size_msd_irx, 3279516); //ingame
	//gen_patch(size_msd_irx, 1331872); //gui
	
	//Disable format button
	if (disableformat==1){
		jal_patch((void*)FormatDisabled, 6524);
	}
	
	//Video mode
	jal_patch((void*)SelectVideoMode, 14108);
	
	//Remove PLEASE WAIT message
	//nop_patch(69356);

	//LoadExecPs2 Hook
	jal_patch((void*)HLoadExecPs2, 69732);
	
	//PCSX2  --> USED FOR EXPERIMENTS WITH PCSX2 ONLY. THIS IS USELESS
	//nop_patch(69704);
	//asm("jal 0x0010ff58");
		
	traducir();

		
}

/*
 * This function force the video mode in the USB ADVANCE game list
 */

int SelectVideoMode(){
	
	FlushCache(0);
	
	if(PAL==1){	
		return 0x45;
	}else{
		return 0x00;
	}
}

/*
 * To do something before launching the game
 */

void HLoadExecPs2(const char *filename, s32 num_args, char *args[]){

	Reset();

	LoadExecPS2(filename, num_args, args);

}

/*
 * Show a message into USB ADVANCE's GUI
 */

void msgbox(char *titulo, char *mensaje, int color){
	if(engui==0)return;
	asm("move $4, %0"::"r"((void*)titulo));
	asm("move $5, %0"::"r"((void*)mensaje));
	asm("move $6, %0"::"r"(color)); //COLOR 0=red 1=green 2=blue
	asm("jal 0x00111a98"); //MSGBOX
	FlushCache(0);
}

/*
 * Show a message if format button is disabled
 */

void FormatDisabled(){
	
	char mensaje[255];
	
	sprintf(mensaje,"%s\n\n%s",txt_formatbuttonisdisabled,txt_youcanchange);

	msgbox(txt_formatdisabled, mensaje,1);
	
	FlushCache(0);

}

/*
 * This function replaces embedded module from USB ADVANCE elf
 */

void ExtraeModulo(void *orig, void *dest, int size, int id){

	char cabe[4];
	char modname[32];
	char tmp[255];

	asm("jal 0x0010a7f8");  //Original ExtractModule function
			
	sbv_patch_enable_lmb();
	sbv_patch_disable_prefix_check();
		
	memcpy(cabe,dest,sizeof(char)*4);
	memcpy(modname,(void*)((int)dest+142),sizeof(modname));  //Get module name
			
	if((int)orig==0x001542B0){ //Isnt a IRX but is EE code
		sprintf(tmp,"Encontrado parche EE\ninterno en %p.\n\n", dest);
	}else{
		if((int)orig==0x00161850){  //These modules haven't name
			strcpy(modname,"RAMDISK");
		}else if((int)orig==0x00162240){
			strcpy(modname,"USBLOADER");
		}else if((int)orig==0x0015A040){
			strcpy(modname,"CDVDMAN");
		}
		if (cabe[1]=='E' && cabe[2]=='L' && cabe[3]=='F'){
			sprintf(tmp, "Encontrado modulo %s\ninterno en %p.\n\n",modname, dest);
		}else{
			//scr_printf("ERROR: No se ha encontrado el modulo en la memoria\n");
			//while(1);
		}
	}
	
	if (!strcmp(modname,"USBD")){
		//scr_printf("Reemplazando %s por %s %s\n", modname, usbd_name, usbd_version);
		
		if(driverexterno==0){
			memset(dest,0,size_usbd_irx);
			memcpy(dest,&usbd_irx,size_usbd_irx);
		}else{
			memset(dest,0,size_load_usbd_irx);
			memcpy(dest,load_usbd_irx,size_load_usbd_irx);
		}
			
	}
	if(!strcmp(modname,"MSD")){
		//memset(dest,0,size_msd_irx);
		//memcpy(dest,&msd_irx,size_msd_irx);
		
		engui=1; // USB ADVANCE GUI is loaded
	}
	
	FlushCache(0);

	return;
}

void nop_patch(u32 offset){
	u32 dir=0x00;
	int addr[4];
	char patch[4];

	addr[3]=((dir)&0xff000000)>>24;
	addr[2]=((dir)&0x00ff0000)>>16;
	addr[1]=((dir)&0x0000ff00)>>8;
	addr[0]=(dir)&0x000000ff;
		
	sprintf(patch,"%c%c%c%c",addr[0],addr[1],addr[2],addr[3]);
	memcpy((void*)(ptr+offset),patch,4);
}

void jal_patch(void *orig, u32 offset){
	u32 dir=JAL((u32)orig);
	int addr[4];
	char patch[4];

	addr[3]=((dir)&0xff000000)>>24;
	addr[2]=((dir)&0x00ff0000)>>16;
	addr[1]=((dir)&0x0000ff00)>>8;
	addr[0]=(dir)&0x000000ff;
		
	sprintf(patch,"%c%c%c%c",addr[0],addr[1],addr[2],addr[3]);
	memcpy((void*)(ptr+offset),patch,4);
}

void gen_patch(u32 dir, u32 offset){
	int addr[4];
	char patch[4];

	addr[3]=((dir)&0xff000000)>>24;
	addr[2]=((dir)&0x00ff0000)>>16;
	addr[1]=((dir)&0x0000ff00)>>8;
	addr[0]=(dir)&0x000000ff;
		
	sprintf(patch,"%c%c%c%c",addr[0],addr[1],addr[2],addr[3]);
	memcpy((void*)(offset),patch,4);
}

void txt_patch(void *txt, u32 offset, int separacion){
	u32 dir=(u32)txt;
	u8 addr[4];
	char patch[4];
		
	addr[0]=((dir)&0xff000000)>>24;
	addr[1]=((dir)&0x00ff0000)>>16;
	addr[2]=((dir)&0x0000ff00)>>8;
	addr[3]=(dir)&0x000000ff;
	
	//Patch
	sprintf(patch,"%c%c",addr[1],addr[0]);
	memcpy((void*)(ptr+offset-separacion),patch,2);
	sprintf(patch,"%c%c",addr[3],addr[2]);
	memcpy((void*)(ptr+offset),patch,2);
		
}
